Package ru.bitel.bgbilling.kernel.contract.api.common.service

# Interface ContractParameterService

    public interface ContractParameterService

Справочник параметров.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `contractParameterGroupAttrDelete​(int id)` | Удаление параметра договора из справочника.
  `ContractParameterGroupAttr` | `contractParameterGroupAttrGet​(int id)` | Получение типа параметра по ID из справочника параметров.
  `java.util.List<ContractParameterGroupAttr>` | `contractParameterGroupAttrList()` | Получение списка параметров договора из справочника.
  `void` | `contractParameterGroupAttrOrderSet​(java.util.List<ContractParameterGroupAttr> list)` |
  `int` | `contractParameterGroupAttrUpdate​(ContractParameterGroupAttr attr)` | Добавление/обновление параметра договора справочника.
  `void` | `contractParameterGroupDelete​(int id)` | Удаление группы параметров по его ID.
  `ContractParameterGroup` | `contractParameterGroupGet​(int id)` | Получение группы параметров договора по ID.
  `java.lang.String` | `contractParameterGroupJson()` | Данные для редактора справочника "группы параметров"
  `java.util.List<ContractParameterGroup>` | `contractParameterGroupList()` | Получение списка групп параметров договора.
  `int` | `contractParameterGroupUpdate​(ContractParameterGroup group)` | Обновление группы параметров.
  `void` | `contractParameterGroupUpdateLink​(int contractParameterGroupId, java.util.Set<java.lang.Integer> parameterIds)` | Обновление привязки параметров к группе.
  `void` | `contractParameterListItemDelete​(int parameterTypeId, int id)` | Удаление значения спискового параметра.
  `java.util.List<ContractParameterListItem>` | `contractParameterListItemList​(int parameterTypeId)` | Получение значений спискового параметра.
  `int` | `contractParameterListItemUpdate​(int parameterTypeId, ContractParameterListItem item)` | Обновление значения спискового параметра.
  `java.lang.String` | `customerContracts​(int customerId, java.time.LocalDateTime onTime)` |
  `java.util.List<java.lang.String>` | `customerEmails​(int customerId, int contractId)` |
  `void` | `customerLinkSet​(int contractId, int сustomerId)` |
  `int` | `customerNewSet​(int contractId)` |
  `java.lang.String` | `customerParameterGet​(int contractId)` |
  `java.lang.String` | `customerParameterHistory​(int customerId, java.lang.String fieldKey, int lastRecordCount)` |
  `java.lang.String` | `customerParameterUpdate​(int customerId, java.lang.String fieldValue, java.lang.String text)` |
  `java.lang.String` | `customerSearch​(Customer.CustomerType customerType, java.lang.String text)` | Поиск клиентов
  `boolean` | `customerUnlinkContract​(int contractId, java.time.LocalDateTime unlinkTime)` |

- ## Method Details

  - ### contractParameterGroupGet

    ContractParameterGroup contractParameterGroupGet​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Получение группы параметров договора по ID. Внутри него содержится список параметров справочника.
    Parameters:
      `id` - ID группы параметров.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupList

    java.util.List<ContractParameterGroup> contractParameterGroupList() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Получение списка групп параметров договора. Внутри каждой группы содержится список параметров справочника.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupJson

    java.lang.String contractParameterGroupJson() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Данные для редактора справочника "группы параметров"
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### contractParameterGroupUpdate

    int contractParameterGroupUpdate​(ContractParameterGroup group) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Обновление группы параметров.
    Parameters:
      `group` - группа параметров
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupDelete

    void contractParameterGroupDelete​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Удаление группы параметров по его ID.
    Parameters:
      `id` - ID группы параметров
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterListItemList

    java.util.List<ContractParameterListItem> contractParameterListItemList​(int parameterTypeId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Получение значений спискового параметра.
    Parameters:
      `parameterTypeId` - pid
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterListItemUpdate

    int contractParameterListItemUpdate​(int parameterTypeId, ContractParameterListItem item) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Обновление значения спискового параметра.
    Parameters:
      `parameterTypeId` - pid
      `item` - значение
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterListItemDelete

    void contractParameterListItemDelete​(int parameterTypeId, int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Удаление значения спискового параметра.
    Parameters:
      `parameterTypeId` - pid
      `id` - значения
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupAttrGet

    ContractParameterGroupAttr contractParameterGroupAttrGet​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Получение типа параметра по ID из справочника параметров.
    Parameters:
      `id` - ID типа параметра договора
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupAttrList

    java.util.List<ContractParameterGroupAttr> contractParameterGroupAttrList() throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Получение списка параметров договора из справочника.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupAttrUpdate

    int contractParameterGroupAttrUpdate​(ContractParameterGroupAttr attr) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Добавление/обновление параметра договора справочника.
    Parameters:
      `attr` -
    Returns:
      ID созданного/обновленного параметра
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupAttrDelete

    void contractParameterGroupAttrDelete​(int id) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Удаление параметра договора из справочника.
    Parameters:
      `id` - ID удаляемого параметра справочника
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupUpdateLink

    void contractParameterGroupUpdateLink​(int contractParameterGroupId, java.util.Set<java.lang.Integer> parameterIds) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException, ru.bitel.bgbilling.common.BGIllegalArgumentException, ru.bitel.bgbilling.common.BGIllegalAccessException
    Обновление привязки параметров к группе.
    Parameters:
      `contractParameterGroupId` - ID группы параметров, к которой будут привязаны параметры
      `parameterIds` - ID параметров, которые будут привязаны к группе
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `ru.bitel.bgbilling.common.BGIllegalArgumentException`
      `ru.bitel.bgbilling.common.BGIllegalAccessException`

  - ### contractParameterGroupAttrOrderSet

    void contractParameterGroupAttrOrderSet​(java.util.List<ContractParameterGroupAttr> list) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerParameterGet

    java.lang.String customerParameterGet​(int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerParameterUpdate

    java.lang.String customerParameterUpdate​(int customerId, java.lang.String fieldValue, java.lang.String text) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerNewSet

    int customerNewSet​(int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerSearch

    java.lang.String customerSearch​(Customer.CustomerType customerType, java.lang.String text) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Поиск клиентов
    Parameters:
      `customerType` -
      true - ищем юр. лиц
      false - ищем физ. лиц
      `text` -
      строка поиска, в зависимости от содержимого строки и значения параметра uPerson ищет по ИНН, серии и номеру паспорта, огрн, названию, дате рождения и дате выдачи паспорта
    Returns:
      json array
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerLinkSet

    void customerLinkSet​(int contractId, int сustomerId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerContracts

    java.lang.String customerContracts​(int customerId, java.time.LocalDateTime onTime) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerUnlinkContract

    boolean customerUnlinkContract​(int contractId, java.time.LocalDateTime unlinkTime) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerParameterHistory

    java.lang.String customerParameterHistory​(int customerId, java.lang.String fieldKey, int lastRecordCount) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`

  - ### customerEmails

    java.util.List<java.lang.String> customerEmails​(int customerId, int contractId) throws ru.bitel.bgbilling.common.BGException, ru.bitel.bgbilling.common.BGMessageException
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`